
package com.littleworld.todo.services;

import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Scope;


import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;

import com.littleworld.todo.model.Todo;

@SuppressWarnings("unchecked")
@Transactional
@Repository
public class TodoService {

    @PersistenceContext
    private EntityManager em;

    public Todo create(Todo todo ) {
        em.persist(todo);
        return todo;
    }

    public List<Todo> findAll() {
        return em.createQuery("from " + Todo.class.getSimpleName()).getResultList();
    }
 
    public Todo findById(Integer id) {
        return em.find(Todo.class, id);
    }

    public void delete(Integer id) {
        Todo todo = findById(id);
        em.remove(todo);
    }

    public Todo update(Todo todo) {
        Todo todoAttached = findById(todo.getId());

        todoAttached.setId(todo.getId());
        todoAttached.setTask(todo.getTask());    
        em.merge(todoAttached);
        return todoAttached;
    }
}

